#ifndef SYSI2_H
#define SYSI2_H

#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/graphics.h>
#include <graphics/gfxmacros.h>
#include <dos.h>
#include <graphics/gfx.h>

#include <stdio.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <utility/tagitem.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/screens.h>
#include <intuition/gadgetclass.h>
#include <intuition/icclass.h>
#include <intuition/imageclass.h>
#include <math.h>


/* Instance data for image objects */
struct SysIData
{
  ULONG si_Which;
  WORD  si_X,
        si_Y;
  WORD  si_Width,
        si_Height,
        si_OW,
        si_OH;
  struct DrawInfo *si_DrawInfo;
};

typedef union MsgUnion
{
  ULONG  MethodID;
  struct opSet    opSet;
  struct opUpdate opUpdate;
  struct opGet    opGet;
  struct impDraw  impDraw;
} *Msgs;

/* prototypes */

ULONG __saveds __asm Dispatcher(register __a0 Class *C, register __a2 struct Image *O, register __a1 Msgs M );
struct BitMap *MyAllocBM(LONG Width, LONG Height, LONG Depth, LONG Flags, struct BitMap *Friend);
void           MyFreeBM(struct BitMap *BM);

/* Draws a multi point line */
void DrawPoly(struct RastPort *RP,LONG Count, ...);

/* Draws a filled polygon upto MAX_FILLPOLYPOINTS, See below */
void FillPoly(struct RastPort *RP,ULONG Points, ...);

/* This function draws the images */
ULONG RenderImage(Class *C, struct Image *Image, Msgs M);

/* Used to draw button backgrounds */
void DrawBack(struct RastPort *RP, 
              UBYTE TopEdgePen,
              UBYTE BottomEdgePen,
              UBYTE FillPen,
              WORD X1,
              WORD Y1,
              WORD X2,
              WORD Y2);

/* RectFill with error checking */
void MyRectFill(struct RastPort *RP,
              WORD X1,
              WORD Y1,
              WORD X2,
              WORD Y2);


#endif /* SYSI2_H */
